<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: index.php                                                 #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

error_reporting(0);
//error_reporting(E_ALL);

if(!file_exists("../config.php")){
    die("<b>You must configure Panda Image Gallery! <br/><br/>Please review config.php.sample, configure as necessary,
        and rename config.php.sample to config.php. <br/><br/>See the README or installation notes for installation details.</b>");
}

include_once '../config.php';
include_once '../class/panda_dir.php';
include_once '../themes/'.$themeName.'/options.php';
include '../functions.php';

include_once '../class/loopvars.php';
$loopvars = new clsLoopVars();

@session_name($sessionIdentifier);
@session_start();
$sessionid=session_id();

$version_string="3.5.8";

if((isset($_GET['cms']) && $_GET['cms']==1 && $unified_mode==1) || (isset($_POST['cms']) && $_POST['cms']==1 && $unified_mode==1) || ($_SESSION['cms']==1 && $unified_mode==1) || $unified_mode==2){
    $cms=1;
    $_SESSION['cms']=1;
    $target=" target='_top' ";
    $backtogallerylink=$base_url;
    $chgPassPath=$base_url;
    $passwordRecoveryPath=$base_url.'?a=pr&cms=1';
    $cms_link="&cms=1";
    $cms_link2="?cms=1";
}else{
    $cms=0;
    $_SESSION['cms']=0;
    $backtogallerylink = "../index.php";
    $chgPassPath='../index.php';
    $passwordRecoveryPath='../index.php?a=pr';
    $cms_link="";
    $cms_link2="";
}

$styleSheetPath='../themes/'.$themeName.'/';
$managementPath='./index.php'.$cms_link2;
$scriptsPath='../scripts/';
$registrationPath='../index.php?a=reg'.$cms_link;
$ajaxLoginPath="index.php?action=plainlogin&amp;cms=$cms";
$loginPath='login.php';
$logoutPath='logout.php';
$sitemapURL='../sitemap.xml.php';
$galleryAdminSortOrder='';

if(isset($_POST['galleryAdminSortOrder']))
    $_SESSION['s_galleryAdminSortOrder']=$_POST['galleryAdminSortOrder'];

//set default gallery sort order is none is selected
if(!isset($_SESSION['s_galleryAdminSortOrder'])){
        $_SESSION['s_galleryAdminSortOrder']="dateDESC";
}
$galleryAdminSortOrder=$_SESSION['s_galleryAdminSortOrder'];

$imggallerypath='../galleries/';
$currentURL=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];

$location='';
$error='';

$action='';
$action=$_GET['action'];

$includeFlag='1'; //only way for our included files to know their included.

if(isset($_GET['action']))
	$action=$_GET['action'];

if(isset($_GET['error']))
	$error=$_GET['error'];


if(isset($_GET['vm'])){
        $vm=$_GET['vm'];
}else{
	$vm='false';
}

if(isset($_SESSION['s_userName'])){
	$username=$_SESSION['s_userName'];
}

$ajaxifythumb=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&amp;vm=ajax\"; }, close: \"\" });' ";
$ajaxifydelete=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", iframe:true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.href+\"&amp;vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifydeleteInput=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", iframe:true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.alt+document.deletefile.filetodelete.value+\"&amp;vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifysetthumbInput=" onClick='$(this).colorbox({width:\"600px\", height:\"500px\", iframe: true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.alt+document.setfile.filetoset.value+\"&amp;vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifycaptionInput=" onClick='$(this).colorbox({width:\"600px\", height:\"400px\", overlayClose: false, iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.alt+document.setcaption.filetoset.value+\"&amp;vm=ajax\"; }, close: \"\", onClosed: function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifynewgallery=" onClick='$(this).colorbox({width:\"700px\", height:\"500px\", overlayClose: false, iframe:true, next: false, title:  \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); }PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifyupload=" onClick='$(this).colorbox({width:\"650px\", height:\"80%\", iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&amp;vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";
$ajaxifylogin=" onClick='$(this).colorbox({width:\"400px\", height:\"300px\", iframe:true, next: false, title: \" \", previous: false, current: false, href:function(){ return this.href+\"&vm=ajax\"; }, close: \"\", onClosed:function(){ if(PandaImageGallery.pageRefresh==1){ $(this).colorbox({width:\"300px\", height:\"200px\", iframe:true, scrolling: false, href: \"updating.html\", open: true, close: \"\" }); } PandaImageGallery.pageRefresh=0; } });' ";


/* DO NOT REMOVE OR MODIFY THIS COPYRIGHT NOTICE UNLESS YOU HAVE PURCHASES A LICENSE WHICH PERMITS ITS REMOVAL OR
   MODIFICATION. YOU ARE REQUIRED TO LINK BACK TO MY WEBSITE AND THIS PROJECTS PAGE.
*/
$is_premium=0;
$copyright='<a href="http://www.schiffner.com/index.php/coding-projects/panda-image-gallery/" target="_blank">
Panda Image Gallery v'.$version_string.'</a> - &copy; 2010 Christopher Schiffner - All Rights Reserved';

//must be a valid user
if(isset($_SESSION['s_userName'])) {

	switch($action){

                case 'deleteimage':

			$galleryname='';
			if(isset($_GET['galleryname'])){
				$galleryname=$_GET['galleryname'];
			}else{
				$galleryname=$_POST['galleryname'];
			}

			$filetodelete='';
                        if(isset($_GET['filetodelete'])){
                                $filetodelete=$_GET['filetodelete'];
                        }else if(isset($_POST['filetodelete'])){
                                $filetodelete=$_POST['filetodelete'];
                        }
            $filetodelete=html_entity_decode($filetodelete, ENT_QUOTES);

            //encoded file name
            $linksafe_file=urlencode(htmlentities($filetodelete, ENT_QUOTES));

			$kickmeto='';
			if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
			}else if(isset($_GET['kickmeto'])){
				$kickmeto=$_GET['kickmeto'];
			}

			$completepath=$imggallerypath.$galleryname."/".$filetodelete;

			//get gallery details
			$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

			if($vm!='ajax'){
				include '../themes/'.$themeName.'/overall_header.php';

				echo "<table width='100%'><tr><td align='left'>
			   	  <span class='status'><b>Confirm Image Deletion</b></span><br/><br/>
				  <span class='statusDESC'><b>Gallery Name:</b> $title<br />
                        	  <b>Gallery Description:</b> $description<br/>
				  <b>Image Name:</b> $filetodelete</span><br/><br/>";
			}else{
                                echo "<html><head><link rel='stylesheet' type='text/css'  href='../themes/{$themeName}/content.css' /></head></html><body class='adminfuncts'>";
                        }

			if(file_exists($imggallerypath.$galleryname."/".$filetodelete)){
				echo "<center>";

				if($vm!='ajax'){
					echo "<a href='dosub.php?action=confirmdeleteimage&galleryname={$galleryname}&filetodelete={$linksafe_file}&vm={$vm}' $target><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
					echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/>";
				}else{
					$ajaxcss=" style='height: 60%;' ";

					if(is_movie($filetodelete)){
						$fileTypeTitle="movie";
					}else{
						$fileTypeTitle="image";
					}

					echo "<br/><span class='status'><b>Are you sure you want to delete this {$fileTypeTitle}?</b></span><br/>";
				}

				if(is_movie($filetodelete)){

					echo "<br/><table><tr><td class='imageTiles'><div style='position: relative; width: 100%; height: 100%'>";
					echo "<a style='padding: 0; margin: 0;'><img src='{$styleSheetPath}images/playMovie.png' border='0' class='imageTiles' alt='{$filetodelete}' /></a>";
	                                echo "<div class='videoTitle'><a>$filetodelete</a></div>";
					echo "</div></td></tr></table>";

	                        }else{
					$imagedimensions = getimagesize($imggallerypath.$galleryname."/".$filetodelete);
					if( (($imagedimensions[0] > $imagesdisplaywidth) && ($imagedimensions[0] > $imagedimensions[1])) ||
						(($imagedimensions[1] > $imagesdisplayheight) && ($imagedimensions[1] > $imagedimensions[0])) ){

						if($protect_image_path || $concealPath){
							echo "<br/><img src='../view.php/".$galleryname."/lowres_".$filetodelete."' alt='{$filetodelete}' class='viewedImage' $ajaxcss /><br/>";
						}else{
							echo "<br/><img src='".$imggallerypath.$galleryname."/lowres_".$filetodelete."' alt='{$filetodelete}' class='viewedImage' $ajaxcss /><br/>";
						}
					}else{
						if($protect_image_path || $concealPath){
							echo "<br/><img src='../view.php/".$galleryname."/".$filetodelete."' alt='{$filetodelete}' class='viewedImage' $ajaxcss /><br/>";
						}else{
							echo "<br/><img src='".$imggallerypath.$galleryname."/".$filetodelete."' alt='{$filetodelete}' class='viewedImage' $ajaxcss /><br/>";
						}
					}
				}
                                if($vm=='ajax'){
                                        echo "<br/><br/><a href='dosub.php?action=confirmdeleteimage&galleryname={$galleryname}&filetodelete={$linksafe_file}&vm={$vm}' onClick='parent.PandaImageGallery.pageRefresh=1;'><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
                                        echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/>";
                                }

				echo "</center>";
			}

			if($vm!='ajax'){
				echo "</td></tr></table>";
				include '../themes/'.$themeName.'/overall_footer.php';
			}else{
				echo "</body></html>";
			}

			break;


                case 'setcaption':

                        $galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }

                        $filetoset='';
                        if(isset($_GET['filetoset'])){
                                $filetoset=$_GET['filetoset'];
                        }else if(isset($_POST['filetoset'])){
                                $filetoset=$_POST['filetoset'];
                        }
                        $filetoset=html_entity_decode($filetoset, ENT_QUOTES);

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){
                                $kickmeto=$_GET['kickmeto'];
                        }

			$completepath=$imggallerypath.$galleryname."/".$filetoset;

			//get gallery details
			$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

			if(file_exists($imggallerypath.$galleryname."/".$filetoset.".php")){
                        	include $imggallerypath.$galleryname."/".$filetoset.".php";
				if($imageDetails[0]==""){
                                        $imageDetails[0]="(enter caption here)";
                                }
                	}else{
				$imageDetails[0]="(enter caption here)";
			}

                        if($vm!='ajax'){
                                include '../themes/'.$themeName.'/overall_header.php';

                                echo "<table width='100%'><tr><td align='left'>
                                  <span class='status'><b>Confirm Thumbnail Selection</b></span><br/><br/>
                                  <span class='statusDESC'><b>Gallery Name:</b> $title<br />
                                  <b>Gallery Description:</b> $description<br/>
                                  <b>Image Name:</b> $filetoset<br/></span><br/>";
                        }else{
                                echo "<html><head><link rel='stylesheet' type='text/css' href='../themes/{$themeName}/content.css' /></head></html><body class='adminfuncts'>";

				if(is_movie($filetoset)){
                                        $fileTypeTitle="Movie";
                                }else{
                                        $fileTypeTitle="Image";
                                }

				echo "<center><span class='status'><strong>Edit {$fileTypeTitle} Caption</strong></span></center>";
                        }

			echo "<table cellspacing='20'><tr><td valign='top' align='center'>";

			if(is_movie($filetoset)){

                                        echo "<br/><div style='position: relative; width: 100%; height: 100%'>";
                                        echo "<a style='padding: 0; margin: 0;'><img src='{$styleSheetPath}images/playMovie.png' border='0' class='imageTiles' alt='{$filetoset}' /></a>";
                                        echo "<div class='videoTitle'><a>$filetoset</a></div>";
                                        echo "</div>";

			}else{
	                        $imagedimensions = getimagesize($imggallerypath.$galleryname."/".$filetoset);
	                        if( (($imagedimensions[0] > $imagesdisplaywidth) && ($imagedimensions[0] > $imagedimensions[1])) ||
	                                (($imagedimensions[1] > $imagesdisplayheight) && ($imagedimensions[1] > $imagedimensions[0])) ){

	                                if($protect_image_path || $concealPath){
	                                        echo "<br/><img src='../view.php/".$galleryname."/thm_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
	                                }else{
	                                        echo "<br/><img src='".$imggallerypath.$galleryname."/thm_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
	                                }
	                        }else{
	                                if($protect_image_path || $concealPath){
	                                        echo "<br/><img src='../view.php/".$galleryname."/thm_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
	                                }else{
	                                        echo "<br/><img src='".$imggallerypath.$galleryname."/thm_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
	                                }
	                        }
			}

			echo "</td><td valign='top'>";

			echo "<br/><form method='post' action='dosub.php?action=saveimagecaption&amp;vm={$vm}' enctype=multipart/form-data>
				<input type='hidden' name='galleryname' value='$galleryname' />
				<input type='hidden' name='filetoset' value='$filetoset' />
				<input type='hidden' name='kickmeto' value='$kickmeto' />
				<textarea name='caption' cols='30' onKeyDown='limitText(this,{$descriptionMaxLength});' onKeyUp='limitText(this,{$descriptionMaxLength});' style='height: 140px; width: 290px;'>$imageDetails[0]</textarea>
				</td></tr><tr><td colspan='2' align='center'>
				<input type='submit' value='' style='background: transparent url(\"../themes/$themeName/images/save.gif\") no-repeat;' class='save' onClick='if(parent.PandaImageGallery.overrideRefresh!=1){ parent.PandaImageGallery.pageRefresh=1; }' />
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input onClick='parent.$.fn.colorbox.close();' type='reset' value='' style='background: transparent url(\"../themes/$themeName/images/cancel.gif\") no-repeat;' class='cancel' />
				</form>";

			echo "</td></tr></table>";

                        if($vm!='ajax'){
                                echo "</td></tr></table>";
                                include '../themes/'.$themeName.'/overall_footer.php';
                        }else{
                                echo "</body></html>";
                        }

                        break;

                case 'setthumb':

			$galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }

			$filetoset='';
                        if(isset($_GET['filetoset'])){
                                $filetoset=$_GET['filetoset'];
                        }else if(isset($_POST['filetoset'])){
                                $filetoset=$_POST['filetoset'];
                        }
                        $filetoset=html_entity_decode($filetoset, ENT_QUOTES);

                        //encoded file name
                        $linksafe_file=urlencode(htmlentities($filetoset, ENT_QUOTES));

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){
                                $kickmeto=$_GET['kickmeto'];
                        }

			if(is_movie($filetoset)){
				if($vm!='ajax'){
                                	if($kickmeto!=''){
                                		header("Location: http://$kickmeto");
                                	}else{
                                		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=vg&g=$galleryname");
                                	}
	                        }else{
	                                echo "<script type='text/javascript'>
	                                            parent.$.fn.colorbox.close();
	                                      </script>";
	                        }
			}

                        $completepath=$imggallerypath.$galleryname."/".$filetoset;

			//get gallery details
			$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

			if($vm!='ajax'){
                        	include '../themes/'.$themeName.'/overall_header.php';

                        	echo "<table width='100%'><tr><td align='left'>
                                  <span class='status'><b>Confirm Thumbnail Selection</b></span><br/><br/>
                                  <span class='statusDESC'><b>Gallery Name:</b> $title<br />
                                  <b>Gallery Description:</b> $description<br/>
                                  <b>Image Name:</b> $filetoset<br/></span><br/>";
			}else{
                                echo "<html><head><link rel='stylesheet' type='text/css'  href='../themes/{$themeName}/content.css' /></head></html><body class='adminfuncts'>";
                        }

			if(file_exists($imggallerypath.$galleryname."/".$filetoset)){

				echo "<center>";

                                if($vm!='ajax'){
                                        echo "<a href='dosub.php?action=confirmsetthumb&galleryname={$galleryname}&filetoset={$linksafe_file}&vm={$vm}' $target><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
                                        echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/>";
                                }else{
                                        $ajaxcss=" style='height: 60%;' ";
                                        echo "<br/><span class='status'><b>Are you sure you want to make this the default gallery thumbnail?</b></span><br/>";
                                }

	                        $imagedimensions = getimagesize($imggallerypath.$galleryname."/".$filetoset);
	                        if( (($imagedimensions[0] > $imagesdisplaywidth) && ($imagedimensions[0] > $imagedimensions[1])) ||
	                                (($imagedimensions[1] > $imagesdisplayheight) && ($imagedimensions[1] > $imagedimensions[0])) ){

					if($protect_image_path || $concealPath){
						echo "<br/><img src='../view.php/".$galleryname."/lowres_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
					}else{
						echo "<br/><img src='".$imggallerypath.$galleryname."/lowres_".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
					}
	                        }else{
					if($protect_image_path || $concealPath){
						echo "<br/><img src='../view.php/".$galleryname."/".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
					}else{
						echo "<br/><img src='".$imggallerypath.$galleryname."/".$filetoset."' alt='{$filetoset}' class='viewedImage' $ajaxcss /><br/>";
					}
	                        }

                                if($vm=='ajax'){
                                        echo "<br/><br/><a href='dosub.php?action=confirmsetthumb&galleryname={$galleryname}&filetoset={$linksafe_file}&vm={$vm}' onClick='parent.PandaImageGallery.pageRefresh=1;'><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
                                        echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/>";
                                }

	                        echo "</center>";
			}

			if($vm!='ajax'){
				echo "</td></tr></table>";
	                        include '../themes/'.$themeName.'/overall_footer.php';
			}else{
				echo "</body></html>";
			}

                        break;

                case 'editgallerydetails':

			$error=$_GET['error'];

                        $galleryname='';
                        if(isset($_GET['galleryname'])){
                                $galleryname=$_GET['galleryname'];
                        }else if(isset($_POST['galleryname'])){
                                $galleryname=$_POST['galleryname'];
                        }

                        $kickmeto='';
                        if(isset($_POST['kickmeto'])){
                                $kickmeto=$_POST['kickmeto'];
                        }else if(isset($_GET['kickmeto'])){
                                $kickmeto=$_GET['kickmeto'];
                        }

                        $completepath=$imggallerypath.$galleryname."/".$filetoset;

			if(file_exists($imggallerypath.$galleryname)){
				//get gallery details
				$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
				$posterID=$galleryInfo[0];
				$datePosted=$galleryInfo[1];
				$title=$galleryInfo[2];
				$description=$galleryInfo[3];
				$sortOrder=$galleryInfo[4];
				$downloadLink=$galleryInfo[5];
				$galleryCopyright=$galleryInfo[6];
				$concealPath=$galleryInfo[7];
			}

			if($sortOrder=="" || !$sortOrder){
			    $sortOrder=$defaultImageSortOrder;
			}

                        if($vm!='ajax'){
                                include '../themes/'.$themeName.'/overall_header.php';
                        }else{
                                echo "<html><head><link rel='stylesheet' type='text/css' href='../themes/{$themeName}/content.css' /></head></html><body class='adminfuncts'>";
                        }

			if(file_exists($imggallerypath.$galleryname)){
				if($vm!='ajax'){
	                        	echo "<table width='100%'><tr><td align='left'>
	                                  <span class='status'><b>Edit Gallery Details</b></span><br/><br/>
	                                  <span class='statusDESC'><b>Gallery Name:</b> $title<br/>
	                                  <b>Gallery Description:</b> $description<br/></span>
	                                  <center>";
	                        }else{
	                                echo "<span class='status'><b>Edit Gallery Details</b></span>";
		                                echo "<br/><br/>";
        	                }
			}else{
				if($vm!='ajax'){
					echo "<table width='100%'><tr><td align='left'>
	                                  <span class='status'><b>Create New Gallery</b></span><br/><center>";
                                }else{
                                        echo "<span class='status'><b>Create New Gallery</b></span>";
                                        echo "<div style='position: relative; display: inline;  float:right;'><a onClick='parent.PandaImageGallery.pageRefresh=0; parent.$.fn.colorbox.close();' href='#'><img src='../themes/".$themeName."/images/close.gif' border=0 /></a></div>";
                                                echo "<br/><br/>";
                                }
			}

			echo "<script  type='text/javascript'>
				<!--
				function limitText(limitField, limitNum) {
				    if (limitField.value.length > limitNum) {
				        limitField.value = limitField.value.substring(0, limitNum);
				    }
				}
				-->
			      </script>";

                        echo "<br/><form method='post' action='dosub.php?action=confirmgallerydetails&amp;vm={$vm}' enctype=multipart/form-data>
                                <input type='hidden' name='galleryname' value='$galleryname' />
				<input type='hidden' name='gallerydate' value='$datePosted' />
                                <input type='hidden' name='kickmeto' value='$kickmeto' />
				<table class='statusDESC' width='100%'>";

			switch ($error){
		            case 'GCblank':
		                echo "<tr><td colspan='3' align='center'><font style='color:red; font-weight:bold;'>Error: You left a field blank. Please make sure you have filled out ALL required fields.</font><br /><br/><br/></td></tr>";
		                break;
			    default:
				echo "<br/><br/>";
				break;
			}

			echo "  <tr>
				<td align='right' valign='top'>
				<b>Gallery Title:</b>
				</td><td align='left' valign='top'>
				<input type='text' name='gallerytitle' size=50 value='{$title}' maxlength='{$titleMaxLength}' onKeyDown='limitText(this,{$titleMaxLength});' onKeyUp='limitText(this,{$titleMaxLength});' /> &nbsp;(Max $titleMaxLength Chars)
				</td></tr><tr><td align='right' valign='top'>
				<b>Gallery Description:</b><br/>(Max $descriptionMaxLength Chars)&nbsp;
				</td><td align='left' valign='top'>
				<textarea name='gallerydesc' cols='50' rows='6' onKeyDown='limitText(this,{$descriptionMaxLength});' onKeyUp='limitText(this,{$descriptionMaxLength});'>$description</textarea>
				</td></tr><tr><td align='right' valign='top'>
				<b>Default Sort Order:</b>
				</td><td>
                        	<select name='galleryViewSortOrder' class='sortForm'>";
	                                if($sortOrder=='dateDESC'){
		                                echo "<option value='dateDESC' SELECTED>Newest to Oldest</option>";
	                                }else{
		                                echo "<option value='dateDESC'>Newest to Oldest</option>";
	                                }
	                                if($sortOrder=='dateASC'){
		                                echo "<option value='dateASC' SELECTED>Oldest to Newest</option>";
	                                }else{
		                                echo "<option value='dateASC'>Oldest to Newest</option>";
	                                }
	                                if($sortOrder=='titleAlphabetical'){
		                                echo "<option value='titleAlphabetical' SELECTED>Image Title</option>";
	                                }else{
		                                echo "<option value='titleAlphabetical'>Image Title</option>";
	                                }
		                echo "</select>
				</td>
				</tr>
                                <tr>
                                <td align='right' valign='top'>
                                <b>Image Protection:</b>
                                </td>
                                <td>
                                <select name='concealPath' class='sortForm'>";
					if($concealPath==0){
                                                echo "<option value='0' SELECTED>Do no conceal the image path</option>";
                                        }else{
                                                echo "<option value='0'>Do no conceal the image path</option>";
                                        }
                                        if($concealPath==1){
                                                echo "<option value='1' SELECTED>Conceal the image path</option>";
                                        }else{
                                                echo "<option value='1'>Conceal the image path</option>";
                                        }
                                echo "</select>
                                </td>
                                </tr>
				<tr>
				<td align='right' valign='top'>
				<b>Image Download Properites:</b>
				</td>
				<td>
                                <select name='downloadLink' class='sortForm'>";
                                        if($downloadLink==0){
                                                echo "<option value='0' SELECTED>Do not allow download</option>";
                                        }else{
                                                echo "<option value='0'>Do not allow download</option>";
                                        }
                                        if($downloadLink==1){
                                                echo "<option value='1' SELECTED>Allow low resoution download</option>";
                                        }else{
                                                echo "<option value='1'>Allow low resoution download</option>";
                                        }
                                        if($downloadLink==2){
                                                echo "<option value='2' SELECTED>Allow High Resolution (original quality) download</option>";
                                        }else{
                                                echo "<option value='2'>Allow High Resolution (original quality) download</option>";
                                        }
                                echo "</select>
				</td>
				</tr>
				<tr>
                                <td align='right' valign='top'>
                                <b>Gallery Copyright:</b>
                                </td>
                                <td>
                                <input type='text' name='gallerycopyright' size=50 value='{$galleryCopyright}' maxlength='{$titleMaxLength}' onKeyDown='limitText(this,{$titleMaxLength});' onKeyUp='limitText(this,{$titleMaxLength});' /> &nbsp;(Max $titleMaxLength Chars)
                                </td>
                                </tr>
				<tr><td align='center' colspan='3'>";

			if (file_exists($imggallerypath.$galleryname)){
                        	echo "<br/><br/><input type='submit' value='' style='background: transparent url(\"../themes/$themeName/images/save.gif\") no-repeat;' class='save' onClick='parent.PandaImageGallery.pageRefresh=1;' />
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input onClick='parent.$.fn.colorbox.close();' type='reset' value='' style='background: transparent url(\"../themes/$themeName/images/cancel.gif\") no-repeat;' class='cancel' />";

			}else{
				echo "<br/><br/><input type='submit' value='' style='background: transparent url(\"../themes/$themeName/images/createNew.gif\") no-repeat;' onClick='parent.PandaImageGallery.pageRefresh=1;' class='createNew' />";
			}

			echo "</td></tr></table>
                              </form>";

                        echo "</center></td></tr></table>";

                        if($vm!='ajax'){
                                include '../themes/'.$themeName.'/overall_footer.php';
                        }else{
                                echo "</body></html>";
                        }

                        break;

                case 'deletegallery':

			$galleryname='';
			if(isset($_POST['galleryname'])){
                            $galleryname=$_POST['galleryname'];
			}else if(isset($_GET['galleryname'])){
			    $galleryname=$_GET['galleryname'];
			}

                        $completepath=$imggallerypath.$galleryname."/".$filetodelete;

			//get gallery details
			$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

                        if($vm!='ajax'){
                                include '../themes/'.$themeName.'/overall_header.php';
                        }else{
                                echo "<html><head><link rel='stylesheet' type='text/css' href='../themes/{$themeName}/content.css' /></head></html><body class='adminfuncts'>";
                        }

			if($vm!='ajax'){
				echo "<table width='100%'><tr><td align='left'>
				<span class='status'><b>Confirm Gallery Deletion</b></span><br/><br/>
	                        <span class='statusDESC'><b>Gallery Name:</b> $title<br />
				<b>Gallery Description:</b> $description</span><br/><br/>
	                        ";
                        }
			echo "<center>";

                        if($vm!='ajax'){
                                echo "<a href='dosub.php?action=confirmdeletegallery&galleryname={$galleryname}&filetodelete={$filetodelete}&vm={$vm}' $target><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
                                echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/><br/>";
                        }else{
                                $ajaxcss=" style='height: 60%;' ";
                                echo "<br/><span class='status'><b>Are you sure you want to delete the gallery named: \"$title\"?</b></span><br/><br/>";
                        }

	                $clsDirListingSample = new clsDirListing($imggallerypath.'/'.$galleryname, 0);
	                $clsDirListingSample->sortOrder("titleAlphabetical");
	                $clsDirListingSample->extensionIncludes(array("jpg", "gif", "png", "jpeg"));
	                $clsDirListingSample->prefixExcludes(array("thm_", "lowres_"));
	                $imagesingallery=$clsDirListingSample->getListing();
	                $clsDirListingSample="";

			$thumbnailimg="";
			//RETRIEVE AND DISPLAY THUMNAIL
			if (file_exists($imggallerypath.$galleryname."/thm.php")) {

                    		include $imggallerypath.$galleryname."/thm.php";

                    		if(file_exists($imggallerypath.$galleryname."/".$galleryThumbnail)){
                        		$thumbnailimg=$galleryThumbnail;
                    		}
                    		if($thumbnailimg!=""){
					$thumbnailimg=str_replace("thm_", "", $thumbnailimg);

					if(file_exists($imggallerypath."/".$galleryname."/lowres_".$thumbnailimg)){
						if($protect_image_path || $concealPath){
	                        			echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/lowres_".$thumbnailimg."' alt='' border='0' /><br />";
						}else{
							echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/lowres_".$thumbnailimg."' alt='' border='0' /><br />";
						}
					}else if(file_exists($imggallerypath."/".$galleryname."/".$thumbnailimg)){
						if($protect_image_path || $concealPath){
							echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/".$thumbnailimg."' alt='' border='0' /><br />";
						}else{
							echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/".$thumbnailimg."' alt='' border='0' /><br />";
						}
					}else{
						if($protect_image_path || $concealPath){
							echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/thm_".$thumbnailimg."' alt='' border='0' /><br />";
						}else{
							echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/thm_".$thumbnailimg."' alt='' border='0' /><br />";

						}
					}
                    		}else{
                        		if(file_exists($imggallerypath."/".$galleryname."/".$imagesingallery[0][0]) && $imagesingallery[0][0]!=''){
						if(file_exists($imggallerypath."/".$galleryname."/lowres_".$imagesingallery[0][0])){
							if($protect_image_path || $concealPath){
		                                                echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/lowres_".$imagesingallery[0][0]."' alt='' border='0' /><br />";
							}else{
								echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/lowres_".$imagesingallery[0][0]."' alt='' border='0' /><br />";
							}
						}else{
							if($protect_image_path || $concealPath){
		                            			echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/".$imagesingallery[0][0]."' alt='' border='0' /><br />";
							}else{
								echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/".$imagesingallery[0][0]."' alt='' border='0' /><br />";
							}
						}
                        		}else{
                            			echo "<img class='viewedImage' src='../themes/{$themeName}/images/na.png' alt='' border=0 />";
                        		}
                    		}
			}else{
                                if(file_exists($imggallerypath."/".$galleryname."/".$imagesingallery[0][0]) && $imagesingallery[0][0]!=''){
                                        if(file_exists($imggallerypath."/".$galleryname."/lowres_".$imagesingallery[0][0])){
						if($protect_image_path || $concealPath){
							echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/lowres_".$imagesingallery[0][0]."' alt='' border='0' /><br />";
						}else{
							echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/lowres_".$imagesingallery[0][0]."' alt='' border='0' /><br />";
						}
                                        }else{
						if($protect_image_path || $concealPath){
							echo "<img $ajaxcss class='viewedImage' src='../view.php/".$galleryname."/".$imagesingallery[0][0]."' alt='' border='0' /><br />";
						}else{
							echo "<img $ajaxcss class='viewedImage' src='".$imggallerypath.$galleryname."/".$imagesingallery[0][0]."' alt='' border='0' /><br />";
						}
                                        }
                                }else{
                                        echo "<img class='viewedImage' src='../themes/{$themeName}/images/na.png' alt='' border=0 />";
                                }
			}


                        if($vm=='ajax'){
                                echo "<br/><br/><a href='dosub.php?action=confirmdeletegallery&galleryname={$galleryname}&filetodelete={$filetodelete}&vm={$vm}' onClick='parent.PandaImageGallery.pageRefresh=1;'><img src='../themes/{$themeName}/images/confirm.gif' class='confirm' /></a>";
                                echo "&nbsp;&nbsp&nbsp;<a onClick='parent.$.fn.colorbox.close();' href='#' ><img src='../themes/{$themeName}/images/cancel.gif' class='cancel' /></a><br/>";
                        }

			echo "</center>";

                        if($vm!='ajax'){
				echo "</td></tr></table><br/><br/>";
                                include '../themes/'.$themeName.'/overall_footer.php';
                        }else{
                                echo "</body></html>";
                        }

                        break;

		case 'uploadimages':

			if($enableUploadLimitOverride){
                		@ini_set("upload_max_filesize", $uploadLimit);
				@ini_set("post_max_size", $uploadLimit);
			}

			if(isset($_POST['galleryname'])){
				$galleryname=$_POST['galleryname'];
			}else{
				if(isset($_GET['galleryname'])){
				        $galleryname=$_GET['galleryname'];
				}
			}

			//get gallery details
			$galleryInfo=get_gallery_details($imggallerypath.$galleryname);
			$posterID=$galleryInfo[0];
			$datePosted=$galleryInfo[1];
			$title=$galleryInfo[2];
			$description=$galleryInfo[3];
			$downloadLink=$galleryInfo[5];
			$galleryCopyright=$galleryInfo[6];
			$concealPath=$galleryInfo[7];

			if($vm!='ajax'){
				include '../themes/'.$themeName.'/overall_header.php';
			}else{
				echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'><html><head><title>Panda Image Gallery - Upload</title><link rel='stylesheet' type='text/css' href='../themes/{$themeName}/content.css' /></head><body class='adminfuncts'>";
			}

			echo "<script type='text/javascript' src='../scripts/fancyupload/mootools.js'></script>
			<script type='text/javascript' src='../scripts/fancyupload/swiff.uploader.js'></script>
			<script type='text/javascript' src='../scripts/fancyupload/fx.js'></script>
			<script type='text/javascript' src='../scripts/fancyupload/fancyupload2.js'></script>
			<script type='text/javascript'>
				/* <![CDATA[ */
				window.addEvent('load', function() {

					// For testing, showing the user the current Flash version.

					var swiffy = new FancyUpload2($('status'), $('fileList'), {
						url: $('uploadForm').action,
						fieldName: 'photos',
						path: '../flash/fancyupload/swiff.uploader.swf',
						typeFilter: {'Images (*.jpg, *.jpeg, *.gif, *.png, *.avi, *.mov, *.wmv, *.mp4, *.flv, *.JPG, *.JPEG, *.GIF, *.PNG, *.AVI, *.MOV, *.WMV, *.MP4, *.FLV)': '*.jpg; *.jpeg; *.gif; *.png; *.avi; *.mov; *.wmv; *.mp4; *.flv; *.JPG; *.JPEG; *.GIF; *.PNG; *.AVI; *.MOV; *.WMV; *.MP4; *.FLV'},
						onLoad: function() {
							$('status').removeClass('hide');
							$('fallback').destroy();
						},
						onFail: function(){
							$('fallback').removeClass('hide');
						},
						// The changed parts!
						debug: true, // enable logs, uses console.log
						target: 'browse' // the element for the overlay (Flash 10 only)
					});

					/**
					 * Various interactions
					 */

					$('browse').addEvent('click', function() {
						/**
						 * Doesn't work anymore with Flash 10: swiffy.browse();
						 * FancyUpload moves the Flash movie as overlay over the link.
						 * (see opeion 'target' above)
						 */

						swiffy.browse();
						return false;
					});

					$('clear').addEvent('click', function() {
						swiffy.overallProgress.set(0);
						swiffy.currentProgress.set(0);
						swiffy.removeFile();
        					parentObj = document.getElementById('onCompleteNotify').parentNode;
        					childObj = document.getElementById('onCompleteNotify');
        					parentObj.removeChild(childObj);
						swiffy.overallTitle.set('html', 'Overall Progress');
						swiffy.currentTitle.set('html', 'File Progress');
						return false;
					});

					$('upload').addEvent('click', function() {
						swiffy.upload();
						return false;
					});

				});
				/* ]]> */
			</script>

                        <table width='100%'><tr><td align='left'>";

			if($vm!='ajax'){
				echo "<span class='status'><b>Upload Images</b></span><br/><br/>
	                        <span class='statusDESC'><b>Gallery Name:</b> $title<br />
	                        <b>Gallery Description:</b> $description</span>
				<br/><br/><span class='statusDESC2'><b>The Maximum Permissible file size is ".ini_get('upload_max_filesize')."</b></span>";
			}else{
				echo "<span class='status'><b>Upload Images</b></span>";
				echo "<div style='position: relative; display: inline; float:right;'><a onClick='parent.PandaImageGallery.pageRefresh=0; parent.$.fn.colorbox.close();' href='#'><img src='../themes/".$themeName."/images/close.gif' border=0 /></a></div>";
				echo "<br/><br/>";
			}

			echo "<center>
					<div id='demo'>
					<form action='swiff.uploader.script.php?galleryname=$galleryname&amp;sessionid=$sessionid' method='post' enctype='multipart/form-data' id='uploadForm'>
						<div id='fallback' class='hide'>
						<p style='width: 90%;'>
						To enable multiple file uploads please install or enable Adobe Flash. If Flash is unavailable or you wish to proceed without Flash please click 'Browse', select an image, and click 'Upload'.
						</p>

						<strong>Upload a Photo or Movie:</strong>
						<input type='file' name='photos' />
						<input type='hidden' name='mode' value='single_file' />
						<input type='hidden' name='vm' value='{$vm}' />
						<input type='submit' value='Upload' onClick='parent.PandaImageGallery.pageRefresh=1; this.className=\"hide\"; $(\"loading_animation\").removeClass(\"hide\");' /><img src='loading2.gif' border=0 id='loading_animation' class='hide' style='margin-left: 23px;'/>
<!--
							<center>
							<br/>Your browser does not support Adobe Flash or the Adobe Flash Player Version 10+ Plugin is not installed. Ealier versions of the plugin are not supported.
							<br/><br/>You can download the Adobe Flash Player at: <a href='http://www.adobe.com/products/flashplayer/' $target>http://www.adobe.com/products/flashplayer/</a>
							<br/><br/>In order to upload files you must install the Adobe Flash Player.<br/><br/>
							</center>
-->
						</div><br/>

						<div id='status' class='hide'>
							<p>
								<a href='#'><img id='browse' src='../themes/".$themeName."/images/browseFiles.gif' border=0 /></a>&nbsp;&nbsp;&nbsp;&nbsp;
								<a href='#' id='clear'><img src='../themes/".$themeName."/images/clearList.gif' border=0 /></a>&nbsp;&nbsp;&nbsp;&nbsp;
								<a href='#' id='upload'><img src='../themes/".$themeName."/images/startUploading.gif' border=0 /></a>
							</p>
							<div>
								<strong class='overall-title'>Overall progress</strong><br />
								<img src='../themes/".$themeName."/images/bar.gif' class='progress overall-progress' />
							</div>
							<div>
								<strong class='current-title'>File Progress</strong><br />
								<img src='../themes/".$themeName."/images/bar.gif' class='progress current-progress' />
							</div>
							<div class='current-text'></div>

							<br/><div id='uploadcomplete' class='UPLOADED hide'><br/>UPLOAD COMPLETE!";

			if($vm!='ajax'){
				echo "<br/><br/><a href='index.php'>Click here to return to Management Panel</a>";
				echo "<br/><br/>You can also click 'clear list' and select additional files to upload</div>";
			}else{
				echo "<br/><br/>You can click 'clear list' and  select additional files to upload</div>";
			}

			echo "			</div>

						<ul id='fileList'></ul>

					</form>
					</div>";

			echo "</center></td></tr></table>";

			if($vm!='ajax'){
				include '../themes/'.$themeName.'/overall_footer.php';
			}else{
				echo "</body></html>";
			}

                	break;

    default:
	include '../themes/'.$themeName.'/overall_header.php';

	echo "<table><tr><td align='left' class='b'>\n";

	//heading
	echo "<br /><b>Creating an image gallery is easy. Simply follow these steps:</b>";
	echo "<ul>";
	echo "<li> Click the 'create new gallery' button below.</li>";
	echo "<li> Enter a gallery title and description on the following page and then click the 'create gallery' button.</li>";
	echo "<li> Once a gallery has been created, locate the gallery below.</li>";
	echo "<li> To add images to your gallery, click the button 'upload images' for the appropriate gallery.
		   Click 'browse files' and select the images or movies you wish to upload. Then click 'start uploading' button to begin
		   uploading the selected files.";
	echo "</ul>";
	echo "</td></tr></table>";

	echo "<table width='100%'><tr><td align='center'>";

	$error='';
	if(isset($_GET['error']))
		$error=$_GET['error'];

	switch($error){
            case 'IMGnofile':
                echo "<br /><font style='color:red; font-weight: bold;'>Error: You did not select a file to upload.</font><br /><br/><br/>";
                break;
            case 'IMGnogalleryname':
            	echo "<br /><font style='color:red; font-weight: bold;'>Error: An unknown error occurred. Please try again later.</font><br /><br/><br/>";
                break;
            case 'IMGexists':
            	echo "<br /><font style='color:red; font-weight: bold;'>Error: That image already exists.</font><br /><br/><br/>";
                break;
            case 'IMGtoobig':
            	echo "<br /><font style='color:red; font-weight: bold;'>Error: The image you are trying to upload exceeds the maximum size.</font><br /><br/><br/>";
                break;
            case 'IMGbadextension':
            	echo "<br /><font style='color:red; font-weight: bold;'>Error: The file type is unsupported.</font><br /><br/><br/>";
                break;
            case 'IMGSuccess':
        	echo "<br /><font style='color:green; font-weight: bold;'>Success: Your file was successfully uploaded.</font><br /><br/><br/>";
                break;
	    case 'GCsuccessful':
		echo "<br /><font style='color:green; font-weight: bold;'>Success: Your gallery has successfully been created</font><br /><br/><br/>";
		break;
	    case 'GCexists':
                echo "<br /><font style='color:red; font-weight: bold;'>Error: You have entered a duplicate identifier. Please choose a different identifier and try again.</font><br /><br/><br/>";
                break;
	    case 'GCblank':
		echo "<br /><font style='color:red; font-weight: bold;'>Error: You left a field blank. Please make sure you have filled out ALL required fields.</font><br /><br/><br/>";
		break;
	    case 'GCfail':
		echo "<br /><font style='color:red; font-weight: bold;'>Error: An unknown error occured. Please try again later.</font><br /><br/><br/>";
		break;
            case 'DELSuccess':
                echo "<br /><font style='color:green; font-weight: bold;'>Success:  The file was deleted.</font><br /><br/><br/>";
                break;
	    case 'DELGSuccess':
		echo "<br /><font style='color:green; font-weight: bold;'>Success:  The gallery was deleted.</font><br/><br/><br/>";
		break;
            case 'THMSuccess':
                echo "<br /><font style='color:green; font-weight: bold;'>Success:  The thumbnail image was selected.</font><br /><br/><br/>";
                break;
	}

	echo "<table width=100%>\n<tr>\n<td class='b'>\n";
		//CREATE GALLERY DISPLAY
                echo "<br/><center><a $ajaxifynewgallery href='index.php?action=editgallerydetails&amp;galleryname=NEW' $target><img src='../themes/{$themeName}/images/createNewBig.gif' border=0 /></a></center>";

	echo "</td></tr></table>";

	//present sorting options for the admin galleries
        echo "<table width='100%'><tr><td align='right'>
	      <form method='post' action='index.php' enctype='multipart/form-data' class='sortForm'><input type='hidden' name='cms' value='{$cms}' />
              Sort by: <select name='galleryAdminSortOrder' class='sortForm' onChange='this.parentNode.submit();'>";
              if($_SESSION['s_galleryAdminSortOrder']=='dateDESC'){
                    echo "<option value='dateDESC' SELECTED>Newest to Oldest</option>";
              }else{
                    echo "<option value='dateDESC'>Newest to Oldest</option>";
              }
              if($_SESSION['s_galleryAdminSortOrder']=='dateASC'){
                    echo "<option value='dateASC' SELECTED>Oldest to Newest</option>";
              }else{
                    echo "<option value='dateASC'>Oldest to Newest</option>";
              }
              if($_SESSION['s_galleryAdminSortOrder']=='dateModifiedDESC'){
                    echo "<option value='dateModifiedDESC' SELECTED>Recently Modified</option>";
              }else{
                    echo "<option value='dateModifiedDESC'>Recently Modified</option>";
              }
              if($_SESSION['s_galleryAdminSortOrder']=='titleAlphabetical'){
                    echo "<option value='titleAlphabetical' SELECTED>Gallery Title</option>";
              }else{
                    echo "<option value='titleAlphabetical'>Gallery Title</option>";
              }
        echo "</select>&nbsp;<input type='submit' value='go' class='sortFormButton' /></form></td></tr></table>";

        /* GET THE DIRECTORY LISTING OF THE GALLERIES DIRECTORY. EACH GALLERY IS IN ITS OWN
           DIRECTORY. IF WE ARE DISPLAYING PERSONAL GALLERIES WE NEED TO TAKE ONE ADDITIONAL STEP
           AND CHECK DIRNAME FORREQUESTED USERS PERSONAL GALLERY STRING.
        */

        $parsedusername=str_replace(" ", "", $username);
	$parsedusername.="_";
        /*
        Create a new directory listing instance and process directory
        */
        $clsDirListingDefault = new clsDirListing($imggallerypath, 3);
        $clsDirListingDefault->sortOrder($galleryAdminSortOrder);
        $clsDirListingDefault->prefixIncludes(array($parsedusername));
        $clsDirListingDefault->excludes(array("logs"));
        $galleries=$clsDirListingDefault->getListing();
        $clsDirListingDefault="";

	echo "<br /><table width='100%' class='c'>\n";

	$counter=0;
	if(empty($galleries)){
		echo "You do not have any galleries";
	}else{
	    foreach ($galleries as $galleryentry){

	    echo "<tr>\n<td class='c' align='left'>\n";

		$galleryentry=$galleryentry[0];

		$counter=$counter+1;

		//get gallery details
		$galleryInfo=get_gallery_details($imggallerypath.$galleryentry);
		$posterID=$galleryInfo[0];
		$datePosted=$galleryInfo[1];
		$title=$galleryInfo[2];
		$description=$galleryInfo[3];
		$sortOrder=$galleryInfo[4];
		$downloadLink=$galleryInfo[5];
		$galleryCopyright=$galleryInfo[6];
		$concealPath=$galleryInfo[7];

		$galleryMasterLink=$backtogallerylink."?a=vg&amp;g=$galleryentry"; //this is just to save typing this everywhere below

		switch($sortOrder){
		    case 'dateDESC':
			$printSortOrder="Newest to Oldest";
			break;

		    case 'dateASC':
			$printSortOrder="Oldest to Newest";
			break;

		    case 'titleAlphabetical':
			$printSortOrder="Image Title";
			break;
		}

		echo "<a href='{$galleryMasterLink}' name='{$galleryentry}' $target><span class='adminGalleryTitle'>$title</span></a><br />";
                echo "$description<br/><br/>";

		if($galleryCopyright!=""){
			echo "<b>Gallery Copyright:</b> ".$galleryCopyright."<br/>";
		}
		echo "<b>Default Sort Order:</b> ".$printSortOrder."<br/>";
		echo "<b>Created:</b> $datePosted<br/><br/>";

                /* THE USER MIGHT HAVE SELECTED THEIR OWN DEFAULT SAMPLE IMAGE FOR THIS GALLERY.
                   IF THEY DID THEN CHECK FOR ITS EXISTENCE AND RETURN ITS PRESENCE. OTHERWISE LETS FIND
                   OUR OWN SAMPLE (THE FIRST IMAGE IN THE GALLERY)
                */
                $clsDirListingSample = new clsDirListing($imggallerypath.'/'.$galleryentry, 5);
		$clsDirListingSample->sortOrder("titleAlphabetical");
                $clsDirListingSample->extensionIncludes(array("jpg", "gif", "png", "jpeg"));
                $clsDirListingSample->prefixIncludes(array("thm_"));
                $sampleimagesingallery=$clsDirListingSample->getListing();
                $clsDirListingSample="";

                $thm_set=0;
                $galleryThumbnail="";
                if (file_exists($imggallerypath.'/'.$galleryentry."/thm.php")) {
                               include $imggallerypath.'/'.$galleryentry."/thm.php";
                        if(file_exists($imggallerypath.'/'.$galleryentry."/".$galleryThumbnail)){
                               $thm_set=1;
                        }
                }

		echo "<table width='100%'><tr><td style='width: 200px;' valign='top' align='left'>";
                /* IF THE USER SPECIFIED A THUMB USE IT, OTHERWISE DISPLAY THE FIRST THUMB WE ENCOUNTER */
                if($thm_set==1){
			if($protect_image_path || $concealPath){
	                        echo "<a href='{$galleryMasterLink}' $target><img alt='' src='../view.php/".$galleryentry."/".$galleryThumbnail."' border='0' /></a>";
			}else{
				echo "<a href='{$galleryMasterLink}' $target><img alt='' src='{$imggallerypath}/{$galleryentry}/{$galleryThumbnail}' border='0' /></a>";
			}
                }else if (count($sampleimagesingallery) > 0){
			if($protect_image_path || $concealPath){
	                        echo "<a href='{$galleryMasterLink}' $target><img alt='' src='../view.php/".$galleryentry."/".$sampleimagesingallery[0][0]."' border='0' /></a>";
			}else{
				echo "<a href='{$galleryMasterLink}' $target><img alt='' src='{$imggallerypath}/{$galleryentry}/{$sampleimagesingallery[0][0]}' border='0' /></a>";
			}
                }else{
                        echo "<a href='{$galleryMasterLink}' $target><img src='../themes/{$themeName}/images/na.png' alt='' border=0 /></a>";
                }
		echo "</td><td valign='top'>";

		echo "<div class='admin_gallery_buttons'>";
		//DISPLAY UPLOAD OPTION
		echo "<br/><a $ajaxifyupload href='index.php?action=uploadimages&amp;galleryname={$galleryentry}&cms={$cms}'><img src='../themes/{$themeName}/images/uploadImages.gif' border=0 /></a>";

                //EDIT GALLERY DETAILS DISPLAY
                echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a $ajaxifynewgallery href='index.php?action=editgallerydetails&amp;galleryname={$galleryentry}&cms={$cms}'><img src='../themes/{$themeName}/images/editGallery.gif' border=0 /></a>";

                //DELETE GALLERY DISPLAY
                echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a $ajaxifydelete href='index.php?action=deletegallery&amp;galleryname={$galleryentry}&cms={$cms}'><img src='../themes/{$themeName}/images/deleteGallery.gif' border=0 /></a>";

		echo "</div>";

	        $clsDirListingDefault = new clsDirListing($imggallerypath.'/'.$galleryentry, 0);
	        $clsDirListingDefault->sortOrder("titleAlphabetical");
	        $clsDirListingDefault->extensionIncludes(array("jpg", "gif", "png", "avi", "mpg", "mpeg", "mov", "wmv", "jpeg", "mp4", "flv"));
	        $clsDirListingDefault->prefixExcludes(array("thm_", "lowres_"));
	        $imagesingallery=$clsDirListingDefault->getListing();
	        $clsDirListingDefault="";

		if (count($imagesingallery) > 0){

			//DELETE DISPLAY
			echo "<form method='post' name='deletefile' action='index.php?action=deleteimage' enctype=multipart/form-data style='padding: 0; margin: 0;'>
			Delete Image From Gallery: <select name='filetodelete' class='adminSelect'>";

			if(is_array($imagesingallery)){
			    foreach($imagesingallery as $value){
                    $value[0]=urlencode(htmlentities($value[0], ENT_QUOTES));
					echo "<option>".$value[0]."</option>";
			    }
			}
			echo "</select><input type='hidden' name='galleryname' value='$galleryentry' />
			<input $ajaxifydeleteInput type='submit' value='Delete File' alt='index.php?action=deleteimage&galleryname={$galleryentry}&filetodelete=' />\n</form>";

			//DISPLAY SET THUMBNAIL
	                echo "<form method='post' name='setfile' action='index.php?action=setthumb' enctype=multipart/form-data style='padding: 0; margin: 0;'>
	                      Set Gallery Thumbnail: <select name='filetoset' class='adminSelect'>";
			if(is_array($imagesingallery)){
	            foreach($imagesingallery as $value){
				    if(!is_movie($value[0])){
                        $value[0]=urlencode(htmlentities($value[0], ENT_QUOTES));
                        echo "<option>".$value[0]."</option>";
				    }
	            }
			}
			echo "</select><input type='hidden' name='galleryname' value='$galleryentry' />
				<input $ajaxifysetthumbInput type='submit' value='Set As Thumbnail' alt='index.php?action=setthumb&galleryname={$galleryentry}&filetoset=' />\n</form>";

			//DISPLAY EDIT CAPTION
                        echo "<form method='post' name='setcaption' action='index.php?action=setcaption' enctype=multipart/form-data style='padding: 0; margin: 0;'>
                              Edit Caption: <select name='filetoset' class='adminSelect'>";
                        if(is_array($imagesingallery)){
                            foreach($imagesingallery as $value){
                                $value[0]=urlencode(htmlentities($value[0], ENT_QUOTES));
                                echo "<option>".$value[0]."</option>";
                            }
                        }
                        echo "</select><input type='hidden' name='galleryname' value='$galleryentry' />
                                <input $ajaxifycaptionInput type='submit' value='Edit Caption' alt='index.php?action=setcaption&galleryname={$galleryentry}&filetoset=' />\n</form>";

		}
		echo "</td></tr></table>";

		//display hr
		if($counter!=count($galleries)){
			echo "</td>\n</tr>\n";
		}
	    }
	}

        echo "</table>\n";

        echo "</td></tr></table>";

	include '../themes/'.$themeName.'/overall_footer.php';

	break;
}

}else{

	switch($action){

	    case 'plainlogin':

		echo "<html><head><link rel='stylesheet' type='text/css'  href='../themes/{$themeName}/content.css' /><title>PANDA Image gallery Login</title></head><body class='adminfuncts'><center>";
		echo "<div style='float: left;'><span class='status'><b>Login</b></span></div>";
		echo "<div style='position: relative; display: inline; float:right;'><a onClick='parent.PandaImageGallery.pageRefresh=0; parent.$.fn.colorbox.close();' href='#'><img src='../themes/".$themeName."/images/close.gif' border=0 /></a></div>";
                echo "<br/><br/>";
                echo "<br/><form method='post' action='{$loginPath}?action=login' >\n";
                echo "<table>\n";
                echo "<tr>\n";
                echo "<td colspan=3 class='b' align='center'>\n";
                echo "<br />\n";

                if($error == "login"){
                        echo "<b>ERROR:</b> Invalid username or password!\n";
                }

                echo "</td>\n";
                echo "</tr>\n";
                echo "<tr>\n";
                echo "<td class='b'>\n";
                echo "Username:<br />Password:\n";
                echo "</td>\n";
                echo "<td>\n";
		echo "<input type='hidden' name='cms' value='{$cms}' /><input type='hidden' name='vm' value='{$vm}' />";
                echo "<input type='hidden' name='action' value='login' />\n<input type='hidden' name='location' value='$currentURL' />\n";
                echo "<input type='text' name='username' class='loginForm' /><br />\n";
                echo "<input type='password' name='password' class='loginForm' /><br />\n";
                echo "</td>\n";
                echo "<td align='center'>\n";
                echo "<input type='submit' value='login' class='loginFormButton' /><br />\n";
                echo "</td></tr><tr><td colspan=3 align='center' class='b'><a href='{$passwordRecoveryPath}' target='_top'>Forgot Password?</a>";
                echo "</td>\n</tr>\n</table>\n";
                echo "</form>\n<br/><br/>";
		echo "</center></body></html>";

		break;

	    default:
                        if(!$location){
                                $location="admin";
                        }

                include '../themes/'.$themeName.'/overall_header.php';

                        echo "<br/><form method='post' action='{$loginPath}?action=login' class='admin_login_form'>\n";
                        echo "<table>\n";
                        echo "<tr>\n";
                        echo "<td colspan=3 class='b' align='center'>\n";
                        echo "<br />\n";

                        if($error == "login"){
                            echo "<b>ERROR:</b> Invalid username or password!\n";
                        }

                        echo "</td>\n";
                        echo "</tr>\n";
                        echo "<tr>\n";
                        echo "<td class='b'>\n";
                        echo "Username:<br />Password:\n";
                        echo "</td>\n";
                        echo "<td>\n";
			echo "<input type='hidden' name='cms' value='{$cms}' /><input type='hidden' name='vm' value='{$vm}' />";
                        echo "<input type='hidden' name='action' value='login' />\n<input type='hidden' name='location' value='$currentURL' />\n";
                        echo "<input type='text' name='username' class='loginForm' /><br />\n";
                        echo "<input type='password' name='password' class='loginForm' /><br />\n";
                        echo "</td>\n";
                        echo "<td align='center'>\n";
                        echo "<input type='submit' value='login' class='loginFormButton' /><br />\n";
                        echo "</td></tr><tr><td colspan=3 align='center' class='b'><a href='{$passwordRecoveryPath}' $target>Forgot Password?</a>";
                        echo "</td>\n</tr>\n</table>\n";
                        echo "</form>\n<br/><br/>";

                include '../themes/'.$themeName.'/overall_footer.php';

		break;
	}

}

unset($loopvars);

?>
