<?php
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: loopvars.php                                              #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\



//This class is designed to manage loop vars. Although not fully adopted in v3.2 gradually adoption will
//continue and new loop vars will be created here.
class clsLoopVars
{

	public $loopvars;

	function __construct() {
		//nothing necessary
	}


	public function set_var($key, $contents)
	{
		$this->loopvars[$key]=$contents;
	}


	public function get_var($key)
	{
		if(isset($this->loopvars[$key])){
			return $this->loopvars[$key];
			exit();
		}else{
			return false;
			exit();
		}
		
		return false;
		exit();
	}


	public function append_after($key, $contents){
		$this->loopvars[$key].=$contents;
	}


	public function append_before($key, $contents){
		$this->loopvars[$key]=$contents.$this->loopvars[$key];
	}


	public function destroy_var($key)
	{
		unset($this->loopvars[$key]);
	}


	public function echo_var($key){
		echo $this->loopvars[$key];
	}


	public function compare($key, $search){
		if($this->loopvars[$key]==$search){
			return true;
			exit();
		}else{
			return false;
			exit();
		}

		return false;
	}

	
	public function var_isset($key){
		if(isset($this->loopvars[$key])){
			return true;
			exit();
		}else{
			return false;
			exit();
		}

		return false;
	}
}
?>
