<?
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: userswrite.php                                            #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

/* USER REGISTRATION FILE WRITE
   writes to the user data to file
*/

include './config.php';
include 'users/users.inc.php';

@session_name($sessionIdentifier);
@session_start();

$action=$_POST['action'];

if((isset($_GET['cms']) && $_GET['cms']==1 && $unified_mode==1) || (isset($_POST['cms']) && $_POST['cms']==1 && $unified_mode==1) || ($_SESSION['cms']==1 && $unified_mode==1) || $unified_mode==2){
    $cms=1;
    $_SESSION['cms']=1;
}else{
    $cms=0;
    $_SESSION['cms']=0;
}

switch($action){

    case 'reg':
	/* DONT LET THIS SCRIPT RUN IF THE FUNCTIONALITY IS DISABLED */
	if(!$allowUserRegistration){
		die ("This functionality is disabled");
	}

	/* RETRIEVE VARS */
	$requestedUsername=preg_replace('/[^a-zA-Z0-9]/', '', $_POST['requestedUsername'] );
	$requestedUsername=strtolower(str_replace(" ", "", trim($requestedUsername)));
	$requestedPassword=trim($_POST['requestedPassword']);
	$requestedPassword2=trim($_POST['requestedPassword2']);
	$stripPass=trim(preg_replace('/[^a-zA-Z0-9]/', '', $_POST['requestedPassword']));
	$userEmailAddress=strtolower(trim($_POST['usersEmailAddress']));
	$usersFirstName=strtolower(trim($_POST['usersFirstName']));
	$usersLastName=strtolower(trim($_POST['usersLastName']));
	$userLevel="standard_user";

	if(!ISSET($_SESSION['captcha'])){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=fieldBlank&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
		break;
	}else{
		$challenge=strtolower($_SESSION['captcha']);
	}
	$response=strtolower(trim($_POST['response']));

	//perform our error checking and provide the user with feedback
	if($users[$requestedUsername][0]==$requestedUsername){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=userTaken&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
	}else if($requestedPassword!=$requestedPassword2){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=passMissMatch&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
	}else if($requestedPassword!=$stripPass){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=passChar&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
	}else if($userEmailAddress=='' || $usersFirstName=='' || $usersLastName=='' || $requestedPassword=='' || $requestedPassword2==''){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=fieldBlank&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
	}else if($challenge!=$response){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=codeMismatch&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&usersFirstName=$usersFirstName&usersLastName=$usersLastName&userEmailAddress=$userEmailAddress&cms=$cms");
	}else{
		$userEmailAddress=htmlentities($userEmailAddress, ENT_QUOTES);
		$usersFirstName=htmlentities(trim($_POST['usersFirstName']), ENT_QUOTES);
	        $usersLastName=htmlentities(trim($_POST['usersLastName']), ENT_QUOTES);
	
		//add the new user to our users array
		$users[]=array($requestedUsername,$requestedPassword,$userEmailAddress,$usersFirstName,$usersLastName,$userLevel);

		//open file and aquire exclusive lock
		$fv=fopen('users/users.inc.php', 'w+');
		flock($fv, LOCK_EX);

		fwrite($fv, "<?php\n\n");
        
		fwrite($fv, "/********************************************************************\n");
		fwrite($fv, "USERS FILE\n\n");
		fwrite($fv, "Below are stores for username, password, and email. All data is stored in an array inside an associative array.\n");
		fwrite($fv, "When adding a new username copy the block below, and change the information as necessary. Remember\n");
		fwrite($fv, "this information is case sensitive. Email and password can be anything you deisre. Passwords are case sensitive.\n");
		fwrite($fv, "Make sure to replace each instance with the correct information. Notice the username appears twice.\n\n");
		fwrite($fv, "Alternately may also enable user registration in 'admin/config.php' and create a user account there.\n\n");
		fwrite($fv, "\$users['USERNAME']=array(\"USERNAME\", \"PASSWORD\", \"EMAILADDRESS\", \"FIRSTNAME\", \"LASTNAME\", \"USER_LEVEL\");\n\n");
		fwrite($fv, "********************************************************************/\n\n");
		fwrite($fv, "\$users=array();\n\n\n\n\n\n\n\n\n");
		fwrite($fv, "/*******************************************************************\n");
		fwrite($fv, "MANUALLY ADD USER ACCOUNTS BELOW\n");
		fwrite($fv, "********************************************************************/\n\n\n");
		fwrite($fv, "/*******************************************************************\n");
		fwrite($fv, "MANUALLY ADD USER ACCOUNTS ABOVE\n");
		fwrite($fv,"********************************************************************/\n\n\n\n\n\n\n\n\n\n\n\n\n");
		fwrite($fv, "/*###############################################################################################################\n");
		fwrite($fv, "################################################################################################################\n");
		fwrite($fv, "DO NOT EDIT ANYTHING BELOW THIS LINE. DO NOT ADD SPACES OR LINE BREAKS TO THE END OF THIS FILE\n");
		fwrite($fv, "DOING SO MAY RESULT ON FILE CORRUPTION AND THE INABILITY TO LOG IN OR REGISTER NEW USERS\n");
		fwrite($fv, "################################################################################################################\n");
		fwrite($fv, "################################################################################################################*/\n\n\n");

		//write out the userlist
		foreach($users as $tempUser){
			if(trim($tempUser[5])==""){
				$tempUser[5]="standard_user";
			}
		      fwrite($fv,"\$users['{$tempUser[0]}']=array('{$tempUser[0]}','{$tempUser[1]}','{$tempUser[2]}','{$tempUser[3]}','{$tempUser[4]}','{$tempUser[5]}');\n");
		}

		fwrite($fv, "\n\n?>");

		//relinquish lock and close file
		flock($fv, LOCK_UN);
		fclose($fv);

		
		$requestedPassword=urlencode("$requestedPassword");
		/* REDIRECT */
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=reg&error=success&requestedUsername=$requestedUsername&requestedPassword=$requestedPassword&cms=$cms");
	}
	break;

    case 'chgpass':

        if(!isset($_SESSION['s_userName'])){
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."index.php?cms=$cms");
                break;
        }

	$currentPassword=trim($_POST['currentPassword']);
        $requestedPassword=trim($_POST['requestedPassword']);
        $requestedPassword2=trim($_POST['requestedPassword2']);
	$stripPass=trim(preg_replace('/[^a-zA-Z0-9]/', '', $_POST['requestedPassword']));

        //perform our error checking and provide the user with feedback
        if($currentPassword=='' || $requestedPassword=='' || $requestedPassword2==''){
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=chgpass&error=fieldBlank&cms=$cms");
        }else if($requestedPassword!=$requestedPassword2){
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=chgpass&error=passMissMatch&cms=$cms");
        }else if($requestedPassword!=$stripPass){
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=chgpass&error=passChar&cms=$cms");
	}else if($users[$_SESSION['s_userName']][1]!=$currentPassword){
                header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=chgpass&error=wrongpass&cms=$cms");
	}else{
		$users[$_SESSION['s_userName']][1]=$requestedPassword;

		//open file and aquire exclusive lock
		$fv=fopen('users/users.inc.php', 'w+');
		flock($fv, LOCK_EX);

		fwrite($fv, "<?php\n\n");
        
                fwrite($fv, "/********************************************************************\n");
                fwrite($fv, "USERS FILE\n\n");
                fwrite($fv, "Below are stores for username, password, and email. All data is stored in an array inside an associative array.\n");
                fwrite($fv, "When adding a new username copy the block below, and change the information as necessary. Remember\n");
                fwrite($fv, "this information is case sensitive. Email and password can be anything you deisre. Passwords arecase sensitive.\n");
                fwrite($fv, "Make sure to replace each instance with the correct information. Notice the username appearstwice.\n\n");
                fwrite($fv, "Alternately may also enable user registration in 'admin/config.php' and create a user accountthere.\n\n");
                fwrite($fv, "\$users['USERNAME']=array(\"USERNAME\", \"PASSWORD\", \"EMAILADDRESS\", \"FIRSTNAME\", \"LASTNAME\", \"USER_LEVEL\");\n\n");
                fwrite($fv, "********************************************************************/\n\n");
                fwrite($fv, "\$users=array();\n\n\n\n\n\n\n\n\n");
                fwrite($fv, "/*******************************************************************\n");
                fwrite($fv, "MANUALLY ADD USER ACCOUNTS BELOW\n");
                fwrite($fv, "********************************************************************/\n\n\n");
                fwrite($fv, "/*******************************************************************\n");
                fwrite($fv, "MANUALLY ADD USER ACCOUNTS ABOVE\n");
                fwrite($fv,"********************************************************************/\n\n\n\n\n\n\n\n\n\n\n\n\n");
                fwrite($fv,"/*###############################################################################################################\n");
                fwrite($fv,"################################################################################################################\n");
                fwrite($fv, "DO NOT EDIT ANYTHING BELOW THIS LINE. DO NOT ADD SPACES OR LINE BREAKS TO THE END OF THISFILE\n");
                fwrite($fv, "DOING SO MAY RESULT ON FILE CORRUPTION AND THE INABILITY TO LOG IN OR REGISTER NEW USERS\n");
                fwrite($fv,"################################################################################################################\n");
                fwrite($fv, "################################################################################################################*/\n\n\n");

		//write out the userlist
		foreach($users as $tempUser){
		      fwrite($fv,"\$users['{$tempUser[0]}']=array('{$tempUser[0]}','{$tempUser[1]}','{$tempUser[2]}','{$tempUser[3]}','{$tempUser[4]}','{$tempUser[5]}');\n");
		}

		fwrite($fv, "\n\n?>");

		//relinquish lock and close file
		flock($fv, LOCK_UN);
		fclose($fv);

		/* REDIRECT */
		header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=chgpass&error=success&cms=$cms");

	}
	break;

    default: 
	header("Location: http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?cms=$cms");

}

?>
