<?php	
//#######################################################################\\
//# Author: Christopher Schiffner                                       #\\
//# Filename: rss.xml.php   	                                            #\\
//# Copyright: Christopher Schiffner, All Rights Reserved               #\\
//# Description: Image gallery software, view readme for more info.     #\\
//#                                                                     #\\
//# License: This software is free to use for personal applications.    #\\
//#          There is a small registration fee for commercial           #\\
//#          applications.  Please contact chris@schiffner.com if       #\\
//#          you wish to use this program on a commercial website.      #\\
//#######################################################################\\

header('Content-Type: text/xml');

        $g_Directory="galleries/";
                
	$includeFlag=1;

        if(!$gp)
                $gp=1;
                
        //get the directory list, each image gallery is in its own directory
        $g_Listing = dir($g_Directory);
        while($entry = $g_Listing->read()) {
            if ($entry != "." && $entry != ".." && $entry !="logs") {
                if(is_dir($g_Directory."/".$entry)) {
                        //To allow for personal gallery display only we add the persons username to the search criteria
                       if (file_exists($g_Directory."/".$entry."/index.php")) {
				$includeFlag='1'; //only way for our included files to know their included.
                                include $g_Directory."/".$entry."/index.php";
         
                                //date posted
                                $sortCriteria=$galleryInfo[1];
                                $sortCriteria=explode("/",$sortCriteria);
                                $sortCriteria=mktime(0,0,0,$sortCriteria[0],$sortCriteria[1],$sortCriteria[2]) ;
                        } else {
                                $sortCriteria=9999999999999999999;
                        }

                        $galleries[]=array($entry, $sortCriteria, $galleryInfo[0], $galleryInfo[2], $galleryInfo[3], $galleryInfo[1]);
                }
            }
        }
        $g_Listing->close();
        sortByDate($galleries, "dateDESC");

echo '<?xml version="1.0" encoding="UTF-8"?>
      <rss version="2.0">
      <channel>';

include 'config.php';

$x=0;
if(count($galleries) > 9){
    $x=9;
}else{
    $x=count($galleries)-1;
}

echo "<title>$galleryTitle</title>
      <link>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php</link>
      <description>$galleryDescription</description>";

$y=0;
for ($y = 0 ; $y <= $x; $y++) {
	echo "<item>\n";
	echo "<title>".$galleries[$y][3].", by ".$galleries[$y][2]."</title>\n";
	echo "<description>".$galleries[$y][4]."</description>\n";
	echo "<link>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/index.php?a=vg&amp;g=".$galleries[$y][0]."</link>\n";
	echo "<pubDate>".$galleries[$y][5]."</pubDate>";
	echo "</item>\n";
}

echo '</channel>
      </rss>';
?>

<?php
//open files with shared locked and returns an array of file contents
function openFile($filename){
        $readsize=4096;
        
        //open file and aquire shared lock 
        $fv=fopen($filename, 'r');
        flock($fv, LOCK_SH);
         
        //initialize vars and get array of file
        $temp=array();
        $counter=0;
        while ($line=fgets($fv, $readsize)) {
          $temp[$counter] = $line;
          $counter=$counter+1;
        }
                
        //relinquish lock and close file
        flock($fv, LOCK_UN);
        fclose($fv);
        
        //return our array
	return $temp;
}       
function natcasesort2d(&$aryInput) {
//this function will sort an array without maintaining keys
  $aryOut='';
 
  $aryTemp = $aryInput;

  if(is_array($aryTemp))
     natcasesort($aryTemp);
        
  if(!empty($aryTemp)){
    foreach ($aryTemp as $value) { //natcasesort will sort our array but it also preserves key associations
      $aryOut[] = $value;           //this way we step through a create a fresh array with no associations
    }   
  }
  $aryInput = $aryOut;           //return array
}
function SortByDate(&$Files, $sortCriteria)
{       
    if($sortCriteria=="dateDESC" || $sortCriteria=="dateModifiedDESC")
        usort($Files, "numericSortDESC");
        
    if($sortCriteria=="dateASC" || $sortCriteria=="dateModifiedASC")
        usort($Files, "numericSortASC");
         
    if($sortCriteria=="titleAlphabetical" || $sortCriteria=="author")
        usort($Files, "alphabeticalSort");
}
function numericSortDESC($a, $b)
{
    return ($a[1] < $b[1]) ? 1 : 0;
}
?>
